//񈳏kVOFf̃vO(skanda-surf)

/*
skanda
non-compressible VOF model program for 3D two-phase flow numerical analysis
2019 July
Numerical Two-Phase Flow Dynamics
A. Minato
*/

#include <math.h>
#include <stdlib.h>
#include <fstream>
#include <iostream>
#include <iomanip>
#include <string>
using namespace std;

#define ixmaxp	21
#define jymaxp	21
#define lzmaxp	401
#define ixmaxpp	22
#define jymaxpp	22
#define lzmaxpp	402
#define kmaxp	160001
#define n6p		7
#define n8p		9
#define n27		27


int nex[n27][kmaxp];						//ȉAO[oϐ̎w
int ixk[kmaxp], jyk[kmaxp], lzk[kmaxp];
int kijl[ixmaxpp][jymaxpp][lzmaxpp];
double tu[kmaxp], tf[kmaxp];
double xlu[kmaxp][n6p], tk[kmaxp][n6p];
double sol[kmaxp], r[kmaxp];
double ar[n6p][kmaxp], dvol[kmaxp];
double dvel[n6p][kmaxp];
double vr[n6p][kmaxp];
double bnv[n6p][kmaxp], dnv[n6p][kmaxp];
double um[kmaxp], vm[kmaxp], wm[kmaxp];
double vol[kmaxp], qv[kmaxp], rq[kmaxp], volbfr[kmaxp];
double pq[kmaxp], fq[kmaxp], ddpp[kmaxp];
double fr[n6p][kmaxp];
double fqx[kmaxp], fqn[kmaxp];
double umx[kmaxp], umn[kmaxp];
double vmx[kmaxp], vmn[kmaxp];
double wmx[kmaxp], wmn[kmaxp];
double qre[kmaxp], fmm[kmaxp];
double umm[kmaxp], vmm[kmaxp], wmm[kmaxp];
double stx[kmaxp], sty[kmaxp], stz[kmaxp];
double cosax[kmaxp], cosay[kmaxp], cosaz[kmaxp];
double dx[n27], dy[n27], dz[n27];
double fqs[kmaxp], dff[kmaxp];
double beta[kmaxp];
double curvex[kmaxp], curvey[kmaxp], curvez[kmaxp];

int ixmax, jymax, lzmax, kmax, n6, n8, n27m;
int iskip, icycle, iplot, maxtime, itermax, ianime;
double rgas, rliq;
double grav, pi;
double pin;
double visco, eddy, sigma;
double t, dcel, dt, dvmax;
double errcrit;
double hu;
double drywall;

unsigned short int nnx, nny, nnz, na;
int nx, ny, nz;
string str;

void input();		//ȉA֐(Tu[`)̓o^
void grid();
void cutk();
void bound();
void setup();
void change();
void memory();
void rember();
void veloc();
void move();
void move0();
void move1();
void voltrs();
void volume();
void pressd();
void Decomp();
void Solver();
void Solve();
void voidfx();
void trsset();
void moftrs();
void mix();
void state();
void fqsmear();
void stsmear();
void koubai();
void suten();
void stsmear();

inline void bswap(unsigned short int &d)	//rbgϊ(gGfBArbOGfBA)
{
	unsigned short int s = d;
	char* ps = (char*)&s;
	char* pd = (char*)&d;
	pd[0] = ps[1];
	pd[1] = ps[0];
}

double sgn(double x) {	//
	double ss;
	if (x >= 0) ss = 1; else ss = -1;
	return ss;
}

double pos(double x) {	//l
	double ss;
	if (x >= 0) ss = x; else ss = 0;
	return ss;
}

double frankx(double x) { //{Ch0܂1ɋ߂Ƃ̏
	double ss;
	ss = pow(x, 20) + pow(1 - x, 20);
	return ss;
}

double f8max(double x1, double x2, double x3, double x4,	//8ϐ̍ől
	double x5, double x6, double x7, double x8) {
	double yy;
	yy = x1;
	if (x2 > yy) yy = x2;
	if (x3 > yy) yy = x3;
	if (x4 > yy) yy = x4;
	if (x5 > yy) yy = x5;
	if (x6 > yy) yy = x6;
	if (x7 > yy) yy = x7;
	if (x8 > yy) yy = x8;
	return yy;
}
double f8min(double x1, double x2, double x3, double x4,	//8ϐ̍ŏl
	double x5, double x6, double x7, double x8) {
	double yy;
	yy = x1;
	if (x2 < yy) yy = x2;
	if (x3 < yy) yy = x3;
	if (x4 < yy) yy = x4;
	if (x5 < yy) yy = x5;
	if (x6 < yy) yy = x6;
	if (x7 < yy) yy = x7;
	if (x8 < yy) yy = x8;
	return yy;
}

double f6max(double x1, double x2, double x3, double x4,	//6ϐ̍ől
	double x5, double x6) {
	double yy;
	yy = x1;
	if (x2 > yy) yy = x2;
	if (x3 > yy) yy = x3;
	if (x4 > yy) yy = x4;
	if (x5 > yy) yy = x5;
	if (x6 > yy) yy = x6;
	return yy;
}
double f6min(double x1, double x2, double x3, double x4,	//6ϐ̍ŏl
	double x5, double x6) {
	double yy;
	yy = x1;
	if (x2 < yy) yy = x2;
	if (x3 < yy) yy = x3;
	if (x4 < yy) yy = x4;
	if (x5 < yy) yy = x5;
	if (x6 < yy) yy = x6;
	return yy;
}

double xhl(double f) {		//̓̃{Chtʍ
	double ha, hl, hm, hr;

	hr = 1; hl = 0;
converge:;
	hm = (hr + hl) / 2;
	ha = 3 * pow(hm, 2) - 2 * pow(hm, 3) - f;
	if (ha > 0) hr = hm; else hl = hm;
	if (fabs(hl - hr) > 1e-9) goto converge;
	return 1 - hm;
}

int main() {	//main֐ Jn

	int	i, ic, j, jmid, k, l;	//[Jϐ̓o^

	ofstream fout1("void.csv");		//o̓t@C̎w
	ofstream fout2("pres.csv");
	ofstream fout3("uvel.csv");
	ofstream fout4("vvel.csv");
	ofstream fout5("wvel.csv");
	ofstream fout6("dens.csv");
	fout1.setf(ios::scientific);	//o͐ľ`w
	fout2.setf(ios::scientific);
	fout3.setf(ios::scientific);
	fout4.setf(ios::scientific);
	fout5.setf(ios::scientific);
	fout6.setf(ios::scientific);

	input();						//֐input()̌Ăяo
	grid();
	setup();
	ic = 0;
	for (icycle = 1; icycle <= maxtime; icycle++) {	//ߓnvZTCNicycle=1maxtime܂Ŏs
		t = (double)icycle*dt;						//TCNicycleɑΉ鎞
		change();
		if (icycle%iskip == 0 || icycle == 1) cout << "time=" << setw(13) << t << setw(13) << (double)icycle / (double)maxtime << endl;	//Ԑis̉ʕ\
		if (icycle%iplot == 0 || icycle == 1) {		//o̓t@Cւ̏
			jmid = jymax / 2;
			fout1 << "time=" << setw(13) << t << endl; //Ԃ̏
			fout2 << "time=" << setw(13) << t << endl;
			fout3 << "time=" << setw(13) << t << endl;
			fout4 << "time=" << setw(13) << t << endl;
			fout5 << "time=" << setw(13) << t << endl;
			fout6 << "time=" << setw(13) << t << endl;

			fq[0] = -1;

			for (l = lzmax; l >= 1; l--) {
				for (i = 1; i <= ixmax; i++) {
					k = kijl[i][jmid][l]; fout1 << setw(13) << fq[k] << ",";		//{Chzfq[k]̏(cfx-z) excelœǂݏo\
				}																	//					k͊iqԍ1~kmax
				for (i = 1; i <= ixmax; i++) {
					k = kijl[i][jmid][l]; fout2 << setw(13) << pq[k] - pin << ",";	//͕zpq[k] - pin̏(cfx-z)
				}
				for (i = 1; i <= ixmax; i++) {
					k = kijl[i][jmid][l]; fout3 << setw(13) << um[k] << ",";		//xxzum[k]̏(cfx-z)
				}
				for (i = 1; i <= ixmax; i++) {
					k = kijl[i][jmid][l]; fout4 << setw(13) << vm[k] << ",";		//yxzvm[k]̏(cfx-z)
				}
				for (i = 1; i <= ixmax; i++) {
					k = kijl[i][jmid][l]; fout5 << setw(13) << wm[k] << ",";		//zxzwm[k]̏(cfx-z)
				}
				for (i = 1; i <= ixmax; i++) {
					k = kijl[i][jmid][l]; fout6 << setw(13) << rq[k] << ",";		//xzrq[k]̏(cfx-z)
				}


				fout1 << endl;
				fout2 << endl;
				fout3 << endl;
				fout4 << endl;
				fout5 << endl;
				fout6 << endl;

			}
		}

		if (icycle == 1 || icycle % ianime == 0 || icycle == maxtime) {

			ic = ic + 1;
			str = to_string(10000 + ic);

			ofstream fout20("paraf" + str + ".vtk");			//paraviewp3D{Chz̏o̓t@C
			ofstream fout21("parap" + str + ".vtk");			//paraviewp3D͕z̏o̓t@C
			ofstream fout25;
			fout25.open("povf" + str + ".df3", ios::binary);	//povrayp3D{Chz̏o̓t@C

			nx = ixmax;
			ny = jymax;
			nz = lzmax;
			fout20 << "# vtk DataFile Version 3.0" << endl;
			fout20 << "vtk output" << endl;
			fout20 << "ASCII" << endl;
			fout20 << "DATASET STRUCTURED_POINTS" << endl;
			fout20 << "DIMENSIONS" << setw(5) << nx << setw(5) << ny << setw(5) << nz << endl;
			fout20 << "ORIGIN 0.0 0.0 0.0" << endl;
			fout20 << "SPACING 1.0 1.0 1.0" << endl;
			fout20 << "POINT_DATA" << setw(8) << nx * ny*nz << endl;
			fout20 << "SCALARS void float" << endl;
			fout20 << "LOOKUP_TABLE default" << endl;
			for (l = 1; l <= lzmax; l++) {
				for (j = 1; j <= jymax; j++) {
					for (i = 1; i <= ixmax; i++) {
						k = kijl[i][j][l];
						if (k >= 1) fout20 << setw(13) << (float)((1 - beta[k]) + fq[k] * beta[k]) << endl;
						else fout20 << setw(13) << (float)1 << endl;
					}
				}
			}

			nx = ixmax;
			ny = jymax;
			nz = lzmax;
			fout21 << "# vtk DataFile Version 3.0" << endl;
			fout21 << "vtk output" << endl;
			fout21 << "ASCII" << endl;
			fout21 << "DATASET STRUCTURED_POINTS" << endl;
			fout21 << "DIMENSIONS" << setw(5) << nx << setw(5) << ny << setw(5) << nz << endl;
			fout21 << "ORIGIN 0.0 0.0 0.0" << endl;
			fout21 << "SPACING 1.0 1.0 1.0" << endl;
			fout21 << "POINT_DATA" << setw(8) << nx * ny*nz << endl;
			fout21 << "SCALARS pressure float" << endl;
			fout21 << "LOOKUP_TABLE default" << endl;

			for (l = 1; l <= lzmax; l++) {
				for (j = 1; j <= jymax; j++) {
					for (i = 1; i <= ixmax; i++) {
						k = kijl[i][j][l];
						if (k >= 1) fout21 << setw(13) << (float)(pq[k] - pin) << endl;
						else fout21 << setw(13) << (float)0 << endl;
					}
				}
			}

			nnx = (unsigned short int) ixmax;
			nny = (unsigned short int) jymax;
			nnz = (unsigned short int) lzmax;
			bswap(nnx); bswap(nny); bswap(nnz);
			fout25.write((char *)&nnx, sizeof(unsigned short int));
			fout25.write((char *)&nny, sizeof(unsigned short int));
			fout25.write((char *)&nnz, sizeof(unsigned short int));

			for (l = 1; l <= lzmax; l++) {
				for (j = 1; j <= jymax; j++) {
					for (i = 1; i <= ixmax; i++) {
						k = kijl[i][j][l];
						if (k >= 1) {
							na = (unsigned short int) ((1 - beta[k] + fq[k] * beta[k]) * 65535.0); // beta[k]͊iqŗH̐߂銄
							bswap(na);
							fout25.write((char *)&na, sizeof(unsigned short int));
						}
						else {
							na = (unsigned short int) (1 * 65535.0);
							bswap(na);
							fout25.write((char *)&na, sizeof(unsigned short int));
						}
					}
				}
			}

			fout20.close();
			fout21.close();
			fout25.close();

		}
	}
	fout1.close();
	fout2.close();
	fout3.close();
	fout4.close();
	fout5.close();
	fout6.close();

	return 0;
}

void input() { // (SSIP)

	pi = 3.141592;	//~
	grav = 9.807;	//d͒萔

	rgas = 41.9;	//C̖x
	rliq = 1128.5;	//t̖x
	visco = 1e-7;	//Ctʂ̓S(tɋ߂)
	eddy = 10;		//QSW
	sigma = 0.0075;	//\ʒ
	pin = 1.09e6;	//͌͋E
	dcel = 0.001 / 20 * 1.084;	//{NZiqTCY
	dt = 1e-6 / 2 / 2;	//^CXebv
	itermax = 10;	//ő唽
	iskip = 200;	//ʏo͂̃XLbv
	errcrit = 1e-6;	//A̎̋e덷
	maxtime = 40000 * 2 * 2; //őTCN(^CXebv)
	iplot = maxtime / 10; //2Do̓XLbv
	ianime = maxtime / 200;	//3Do̓XLbv(̗ł͉摜200̏o)

	hu = 1;	//x(Sx[X)

	drywall = 0;
}



void setup() {	//̐ݒ

	int k;

	if (iplot < 1) iplot = 1;
	for (k = 1; k <= kmax; k++) {	//Siqk=1~kmaxɂĎw
		pq[k] = pin;				//pq[k]pinňl
		um[k] = 0; vm[k] = 0; wm[k] = 0;	//x,y,zxum[k],vm[k],wm[k]0
		stx[k] = 0; sty[k] = 0; stz[k] = 0; //x,y,z\ʒ͂ɂstx[k],sty[k],stz[k]0

		if (jyk[k] <= (jymax / 1)) fq[k] = 0;									//{Chfq[k]1
		else fq[k] = 1;
		//		fq[k] = 0;
		rq[k] = fq[k] * rgas + (1 - fq[k])*rliq;	//iq񑊗̖xrq[k]^
		qv[k] = vol[k];								//̑̐qv[k]iq̐vol[k]
	}
}

void change() { //ߓnvZ X̊֐(Tu[`)̈Ӗ͂ꂼ̊֐Ő

	int iter;
	memory();
	veloc();
	move();
	move0();
	voltrs();
	volume();
	iter = 0;
poisson:;
	iter++;
	pressd();
	rember();
	move1();
	voltrs();
	volume();
	if (dvmax > errcrit && iter < itermax) goto poisson; //A̎̎CȂpoissonɖ߂
	fqsmear();
	koubai();
	voidfx();
	trsset();
	moftrs();
	mix();
	state();
	suten();
	stsmear();
}

void memory() { //AvZO̊eiq̑̐qv[k]L

	int k;

	for (k = 1; k <= kmax; k++) volbfr[k] = qv[k];
}

void rember() { //AvZȂ̂ߊeiq̗̑̐ςɖ߂

	int k;

	for (k = 1; k <= kmax; k++) qv[k] = volbfr[k];
}

void veloc() { //xvZ

	int k, n;

	for (k = 1; k <= kmax; k++) {

		um[k] = um[k] + (-dvel[1][k] + dvel[3][k]) / 2.0 + stx[k] / rq[k] * dt; //iqSxxɊiqEǉx𔽉fC\ʒ͂ɂ͂̌ʂ
		vm[k] = vm[k] + (dvel[2][k] - dvel[4][k]) / 2.0 + sty[k] / rq[k] * dt - grav * dt;	//dvel͊iqEɂǉxCY1west(x)A2north(y)
		wm[k] = wm[k] + (-dvel[5][k] + dvel[6][k]) / 2.0 + stz[k] / rq[k] * dt;	//3east(x)A4south(y)
	}																			//5down(z)C6up(z)̋E

	for (k = 1; k <= kmax; k++) {
		for (n = 1; n <= n6; n++) { dvel[n][k] = 0; vr[n][k] = 0; } //iqE̒ǉxdvel[n][k]ƗAxvr[n][k]̃[NA n1~6ƂӖ͏L
	}
}

void move() { //iqԗȂ̐ς̌vZ

	int k, kn, n;

	for (k = 1; k <= kmax; k++) {		//iqkn̗Axvr[n][k],̖xrq[k]Crq[kn]̏d݂ŕ
		for (n = 1; n <= n6; n++) {
			kn = nex[n][k];	//nex[n][k]͊iqknɗאڂiqԍCאڊiqȂǂ̂Ƃ-1C͋ÊƂ-2^
			if (kn >= 1) {
				if (n == 1) vr[n][k] = -(um[k] * rq[k] + um[kn] * rq[kn]) / (rq[k] + rq[kn]);
				if (n == 3) vr[n][k] = (um[k] * rq[k] + um[kn] * rq[kn]) / (rq[k] + rq[kn]);
				if (n == 2) vr[n][k] = (vm[k] * rq[k] + vm[kn] * rq[kn]) / (rq[k] + rq[kn]);
				if (n == 4) vr[n][k] = -(vm[k] * rq[k] + vm[kn] * rq[kn]) / (rq[k] + rq[kn]);
				if (n == 5) vr[n][k] = -(wm[k] * rq[k] + wm[kn] * rq[kn]) / (rq[k] + rq[kn]);
				if (n == 6) vr[n][k] = (wm[k] * rq[k] + wm[kn] * rq[kn]) / (rq[k] + rq[kn]);
			}
			if (kn == -2) {
				if (n == 1) vr[n][k] = -um[k];
				if (n == 3) vr[n][k] = um[k];
				if (n == 2) vr[n][k] = vm[k];
				if (n == 4) vr[n][k] = -vm[k];
				if (n == 5) vr[n][k] = -wm[k];
				if (n == 6) vr[n][k] = wm[k];
			}
		}
	}


	for (k = 1; k <= kmax; k++) {
		for (n = 1; n <= n6; n++) {
			if (nex[n][k] == -1) bnv[n][k] = 0;
			else bnv[n][k] = ar[n][k] * vr[n][k] * dt;//bnv[n][k]͊iqknɃ^CXebvdtԂɗo闬̑̐
		}											// ar[n][k]͊iqE̖ʐ
	}
}

void move0() {		//iqEň͌zɋ쓮ǉxvZiX^K[hiqj
	int k, kn, n;
	double aau, dpdl;
	double rbar, pdyn;

	for (k = 1; k <= kmax; k++) {
		for (n = 1; n <= n6; n++) {
			kn = nex[n][k];
			if (kn >= 1) {
				dpdl = (pq[k] - pq[kn]) / dcel;		//dpdl͊iqË͌z iq͍̈iqԋŏ
				rbar = (rq[k] + rq[kn]) / 2;		//rbar͊iqE̗̖xŗiq̕
				aau = dpdl / rbar;				//aau͊iqEɂ闬̂̉x
			}
			if (kn == -2) {
				dpdl = (pq[k] - pin) / dcel;
				rbar = (rq[k] + rgas) / 2;
				aau = dpdl / rbar;
			}
			if (kn == -1) {						//Eǖʂ̂ƂCE͓͂Ɛ
				if (n == 1) pdyn = rq[k] * (-um[k])*fabs(um[k]);
				if (n == 2) pdyn = rq[k] * (vm[k])*fabs(um[k]);
				if (n == 3) pdyn = rq[k] * (um[k])*fabs(um[k]);
				if (n == 4) pdyn = rq[k] * (-vm[k])*fabs(um[k]);
				if (n == 5) pdyn = rq[k] * (-wm[k])*fabs(um[k]) + rq[k] * grav*dcel;
				if (n == 6) pdyn = rq[k] * (wm[k])*fabs(um[k]) - rq[k] * grav*dcel;
				dpdl = -pdyn / dcel;
				rbar = rq[k];
				aau = dpdl / rbar;
			}

			dvel[n][k] += aau * dt; //dvel[n][k]͊iqkn̒ǉxCc++Ɠ́u+=vɒ
			bnv[n][k] += ar[n][k] * aau*dt*dt;	//ǉxɂA̐ςiqԗA̐ςɉ
			dnv[n][k] = pos(bnv[n][k]);		//A̐ς͐l(o)̂ݍlClɑΉ闬͗אڂvZ
		}
	}
}



void move1() { //SIMPLE@ɂiq̕␳ddpp[k]ɂxaauƂɂǉxdvel[n][k]ƗA̐dnv[n][k]
			   //ɂǉxdvel[n][k]ƗA̐dnv[n][k]̕ωvZ
	int k, kn, n;
	double aau;

	for (k = 1; k <= kmax; k++) {
		for (n = 1; n <= n6; n++) {
			kn = nex[n][k];
			if (kn >= 1)  aau = (ddpp[k] - ddpp[kn]) / ((rq[k] + rq[kn])*dcel / 2.0);
			if (kn == -1) aau = 0;
			if (kn == -2) aau = ddpp[k] / ((rq[k] + rgas)*dcel / 2.0);
			dvel[n][k] += aau * dt;
			bnv[n][k] += ar[n][k] * aau*dt*dt;
			dnv[n][k] = pos(bnv[n][k]);
		}
	}
}


void voltrs() {	//iqԗ̑̐ϗAdnv[n][k]pĊiq̑̐qv[k]̕ω

	int k, kn, n;

	for (k = 1; k <= kmax; k++) {
		for (n = 1; n <= n6; n++) {
			kn = nex[n][k];
			if (kn >= 1) {
				qv[k] -= dnv[n][k];
				qv[kn] += dnv[n][k];
			}
			if (kn == -2) qv[k] -= bnv[n][k];
		}
	}
}

void volume() { //iq̑̐ςƊiq̐vol[k]̍dvol[k]A̎̌덷

	int k;

	dvmax = 0;
	for (k = 1; k <= kmax; k++) {
		dvol[k] = qv[k] - vol[k];
		if (fabs(dvol[k]) > dvmax) dvmax = fabs(dvol[k]);	//dvmax͘A̎덷̍ől
	}
}

void pressd() {

	int k, kn, n;
	double d[kmaxp];
	double dxrn;

	for (k = 1; k <= kmax; k++) {
		for (n = 1; n <= n6; n++) {	//SIMPLE@ɂ␳ddpp[k]߂ǍWstk[k][n]
			kn = nex[n][k];
			if (kn >= 1)  dxrn = 1 / ((rq[k] + rq[kn])*dcel / 2.0);
			if (kn == -1) dxrn = 0;
			if (kn == -2) dxrn = 1 / ((rq[k] + rgas)*dcel / 2.0);


			tk[k][n] = -ar[n][k] * dxrn * dt*dt;
		}
		tk[k][0] = tk[k][1] + tk[k][2] + tk[k][3] + tk[k][4] + tk[k][5] + tk[k][6];
		tk[k][0] = fabs(tk[k][0]);
		d[k] = sqrt(tk[k][0]);
	}
	for (k = 1; k <= kmax; k++) {
		tk[k][0] = 1;
		for (n = 1; n <= n6; n++) {
			kn = nex[n][k];
			if (kn > k) tk[k][n] /= (d[k] * d[kn]); else tk[k][n] = 0;	//Ίpvf1ɋKi
		}
	}
	Decomp();	//z@ɂO
	for (k = 1; k <= kmax; k++) tf[k] = dvol[k] / d[k];
	Solver();	//z@ɂtu[k]
	for (k = 1; k <= kmax; k++) {
		ddpp[k] = tu[k] / d[k];		//ΊpvfKiʂ̕
		pq[k] += ddpp[k];
	}

}

void Decomp() {	//z@ɂO

	int i, j, k, l;
	double uk[kmaxp];
	double qq;

	for (k = 1; k <= kmax; k++) {
		for (j = 0; j <= n6; j++) xlu[k][j] = tk[k][j];
	}

	for (k = 1; k <= kmax; k++) {
		for (j = 1; j <= n6; j++) uk[j] = xlu[k][j];
		for (i = 1; i <= n6; i++) {
			l = nex[i][k];
			if (l > k) {
				qq = xlu[k][i];
				for (j = i; j <= n6; j++) xlu[l][j - i] -= qq * uk[j];
			}
		}
	}
}

void Solver() {//z@ɂtu[k]

	int i, j, k, l, kais;
	double ap[kmaxp];
	double p[kmaxp];
	double alpha, beta1, eps, pap, ss, res, sigma;

	for (i = 1; i <= kmax; i++) {
		tu[i] = 0;
		r[i] = tf[i];
	}

	for (k = 1; k <= kmax; k++) {
		for (j = 1; j <= n6; j++) {
			l = nex[j][k];
			if (l > k) {
				r[k] -= tk[k][j] * tu[l];
				r[l] -= tk[k][j] * tu[k];
			}
		}
	}

	Solve();

	for (i = 1; i <= kmax; i++) p[i] = sol[i];
	ss = 0;
	for (i = 1; i <= kmax; i++) ss += tf[i] * tf[i];

	if (ss == 0) goto loopend;

	eps = (double)kmax*ss*1e-8;

	res = 0;
	for (i = 1; i <= kmax; i++) res += r[i] * r[i];

	ss = 0;
	for (i = 1; i <= kmax; i++) ss += r[i] * p[i];

	sigma = ss;

	for (kais = 1; kais <= 100; kais++) {

		if (res < eps) goto loopend;
		for (i = 1; i <= kmax; i++) ap[i] = tk[i][0] * p[i];
		for (i = 1; i <= kmax; i++) {
			for (j = 1; j <= n6; j++) {
				l = nex[j][i];
				if (l > i) {
					ap[i] += tk[i][j] * p[l];
					ap[l] += tk[i][j] * p[i];
				}
			}
		}

		pap = 0;
		for (i = 1; i <= kmax; i++) pap += p[i] * ap[i];
		alpha = sigma / pap;
		for (i = 1; i <= kmax; i++) {
			tu[i] += alpha * p[i];
			r[i] -= alpha * ap[i];
		}

		Solve();

		ss = 0;
		for (i = 1; i <= kmax; i++) ss += r[i] * sol[i];
		beta1 = ss / sigma;
		sigma = ss;
		for (i = 1; i <= kmax; i++) p[i] = sol[i] + beta1 * p[i];
		res = 0;
		for (i = 1; i <= kmax; i++) res += r[i] * r[i];
	}
loopend:;

}

void Solve() {
	int i, j, k, l;

	double pp, ss;

	for (i = 1; i <= kmax; i++) sol[i] = r[i];
	for (k = 1; k <= kmax - 1; k++) {
		pp = xlu[k][0];
		sol[k] /= pp;
		for (j = 1; j <= n6; j++) {
			l = nex[j][k];
			if (l > k) sol[l] -= xlu[k][j] * sol[k];
		}
	}

	sol[kmax] /= xlu[kmax][0];

	for (i = kmax - 1; i >= 1; i--) {
		ss = 0;
		for (j = 1; j <= n6; j++) {
			l = nex[j][i];
			if (l > i) ss += xlu[i][j] * sol[l];
		}
		sol[i] -= ss / xlu[i][0];
	}
}



void trsset() { //xAvZʂ̋eő,ŏl(͂̊iq̍ő,ŏl)
				//AvZʂ͈̔͊OłΔ񕨗IȐlUƔf
	int k, kn, n;
	double umax, umin, vmax, vmin, wmax, wmin;

	for (k = 1; k <= kmax; k++) {
		umax = um[k]; umin = um[k];
		vmax = vm[k]; vmin = vm[k];
		wmax = wm[k]; wmin = wm[k];
		for (n = 1; n <= n6; n++) {
			kn = nex[n][k];
			if (kn >= 1) {
				if (um[kn] > umax) umax = um[kn];	//umax,uminxx̍ő,ŏl
				if (um[kn] < umin) umin = um[kn];
				if (vm[kn] > vmax) vmax = vm[kn];	//vmax,vminyx̍ő,ŏl
				if (vm[kn] < vmin) vmin = vm[kn];
				if (wm[kn] > wmax) wmax = wm[kn];	//wmax,wminxx̍ő,ŏl
				if (wm[kn] < wmin) wmin = wm[kn];
			}
		}
		fqx[k] = 1; fqn[k] = 0;				//{Ch1,0ő,ŏlƂ
		umx[k] = hu * umax + (1 - hu)*um[k];	//ő,ŏlɘaĕۑ,hu=1̂ƂɘaȂ
		umn[k] = hu * umin + (1 - hu)*um[k];
		vmx[k] = hu * vmax + (1 - hu)*vm[k];
		vmn[k] = hu * vmin + (1 - hu)*vm[k];
		wmx[k] = hu * wmax + (1 - hu)*wm[k];
		wmn[k] = hu * wmin + (1 - hu)*wm[k];
	}
}

void moftrs() {	//{Chfq[k]Ƒxum[k],vm[k],wm[k]̊iqԗAvZ
				//S{ł邪I[o[V[g,A_[V[gƂ㍷ĉ
#define fu 0.5

	int k, kn, n;
	double fqkn[n6p], umkn[n6p], vmkn[n6p], wmkn[n6p];
	double f1, f2, f3, u1, u3, v1, v3, w1, w3;
	double ft, ut, vt, wt;
	double unt, vnt, wnt;
	double fnew, unew, vnew, wnew;
	double af, au, av, aw;
	double bbnv, ddnv, fqk;
	double fs, us, vs, ws, fne, une, vne, wne;

	for (k = 1; k <= kmax; k++) {
		qre[k] = vol[k];
		umm[k] = qre[k] * um[k];
		vmm[k] = qre[k] * vm[k];
		wmm[k] = qre[k] * wm[k];
		fmm[k] = qre[k] * fq[k];
	}

	for (k = 1; k <= kmax; k++) {
		f1 = 0; f2 = qre[k]; f3 = 0;
		u1 = 0; u3 = 0;
		v1 = 0; v3 = 0;
		w1 = 0; w3 = 0;
		ft = fq[k]; ut = um[k]; vt = vm[k]; wt = wm[k];
		for (n = 1; n <= n6; n++) {
			kn = nex[n][k];
			if (kn >= 1) {
				unt = um[kn]; vnt = vm[kn]; wnt = wm[kn];
				umkn[n] = ut * (1 - fu) + fu * unt;	//umkn[n]͊iqknɗAxx
				vmkn[n] = vt * (1 - fu) + fu * vnt;	// fu=0̂Ƃ,0.5̂ƂS
				wmkn[n] = wt * (1 - fu) + fu * wnt;
				fqkn[n] = fr[n][k];
			}
		}

		for (n = 1; n <= n6; n++) {
			kn = nex[n][k];
			if (kn >= 1) {
				f1 += dnv[n][k] * fqkn[n];
				f2 -= dnv[n][k];
				f3 += dnv[n][k] * (fq[k] - fqkn[n]);
				u1 += dnv[n][k] * umkn[n];
				u3 += dnv[n][k] * (um[k] - umkn[n]);
				v1 += dnv[n][k] * vmkn[n];
				v3 += dnv[n][k] * (vm[k] - vmkn[n]);
				w1 += dnv[n][k] * wmkn[n];
				w3 += dnv[n][k] * (wm[k] - wmkn[n]);
			}
		}

		for (n = 1; n <= n6; n++) {
			kn = nex[n][k];
			if (kn == -2) {
				f1 += dnv[n][k] * fq[k];
				f2 -= dnv[n][k];
				u1 += dnv[n][k] * um[k];
				v1 += dnv[n][k] * vm[k];
				w1 += dnv[n][k] * wm[k];
			}
		}

		fnew = (fmm[k] - f1) / f2; unew = (umm[k] - u1) / f2; vnew = (vmm[k] - v1) / f2; wnew = (wmm[k] - w1) / f2;
		af = 0; au = 0; av = 0; aw = 0;
		if (fnew > fqx[k] && f3 != 0) af = (fnew - fqx[k])*f2 / f3;
		if (fnew < fqn[k] && f3 != 0) af = (fnew - fqn[k])*f2 / f3;
		if (unew > umx[k] && u3 != 0) au = (unew - umx[k])*f2 / u3;
		if (unew < umn[k] && u3 != 0) au = (unew - umn[k])*f2 / u3;
		if (vnew > vmn[k] && v3 != 0) av = (vnew - vmx[k])*f2 / v3;
		if (vnew < vmn[k] && v3 != 0) av = (vnew - vmn[k])*f2 / v3;
		if (wnew > wmx[k] && w3 != 0) aw = (wnew - wmx[k])*f2 / w3;
		if (wnew < wmn[k] && w3 != 0) aw = (wnew - wmn[k])*f2 / w3;
		if (af > 1) af = 1; if (af < 0) af = 0;
		if (au > 1) au = 1; if (au < 0) au = 0;
		if (av > 1) av = 1; if (av < 0) av = 0;
		if (aw > 1) aw = 1; if (aw < 0) aw = 0;

		for (n = 1; n <= n6; n++) {
			kn = nex[n][k];
			ddnv = dnv[n][k];
			ft = fq[k]; ut = um[k]; vt = vm[k]; wt = wm[k];
			if (kn >= 1) {
				fne = fqkn[n];
				une = umkn[n];
				vne = vmkn[n];
				wne = wmkn[n];
				fs = fne - af * (fne - ft);
				us = une - au * (une - ut);
				vs = vne - av * (vne - vt);
				ws = wne - aw * (wne - wt);
				qre[k] -= ddnv;
				fmm[k] -= ddnv * fs;
				umm[k] -= ddnv * us;
				vmm[k] -= ddnv * vs;
				wmm[k] -= ddnv * ws;
				qre[kn] += ddnv;
				fmm[kn] += ddnv * fs;
				umm[kn] += ddnv * us;
				vmm[kn] += ddnv * vs;
				wmm[kn] += ddnv * ws;
			}
			if (kn == -2) {
				qre[k] -= ddnv;
				fmm[k] -= ddnv * fs;
				umm[k] -= ddnv * us;
				vmm[k] -= ddnv * vs;
				wmm[k] -= ddnv * ws;
				if (bnv[n][k] < 0) {
					bbnv = -bnv[n][k];
					qre[k] += bbnv;
					fmm[k] += bbnv * 1;
				}
			}
		}
	}


	for (k = 1; k <= kmax; k++) {
		um[k] = umm[k] / qre[k];
		vm[k] = vmm[k] / qre[k];
		wm[k] = wmm[k] / qre[k];
		fqk = fmm[k] / qre[k];
		if (fqk > 1) fqk = 1;
		if (fqk < 0) fqk = 0;
		fq[k] = fqk - 1 + 1;	//u-1 +1v͐lmCY̌
	}
}

void mix() {

	int k, kn, n;
	double qmm[kmaxp], umm[kmaxp], vmm[kmaxp], wmm[kmaxp];
	double diff, difft, dmas, eddyvis, qrmin;
	double dfilm, fact, dmole;


	for (k = 1; k <= kmax; k++) {
		qmm[k] = qv[k] * rq[k];
		umm[k] = um[k] * qmm[k]; vmm[k] = vm[k] * qmm[k]; wmm[k] = wm[k] * qmm[k];
	}
	eddyvis = eddy * visco;
	diff = eddyvis * dt / pow(dcel, 2);
	for (k = 1; k <= kmax; k++) {
		difft = diff + 4 * fq[k] * (1 - fq[k])*0.01*0.3;
		//		difft = diff;
		for (n = 1; n <= n6; n++) {
			kn = nex[n][k];
			if (kn >= 1) {
				qrmin = qv[k] * rq[k];
				if (qrmin > qv[kn] * rq[kn]) qrmin = qv[kn] * rq[kn];
				dmas = difft * qrmin;
				qmm[kn] += dmas;
				umm[kn] += dmas * um[k];
				vmm[kn] += dmas * vm[k];
				wmm[kn] += dmas * wm[k];
			}
		}
	}

	for (k = 1; k <= kmax; k++) {
		um[k] = umm[k] / qmm[k];
		vm[k] = vmm[k] / qmm[k];
		wm[k] = wmm[k] / qmm[k];
	}

	dmole = 25e-6;
	for (k = 1; k <= kmax; k++) {
		diff = eddyvis * dt / pow(dcel*pow(beta[k], 0.3333) / 2, 2);
		for (n = 1; n <= n6; n++) {
			kn = nex[n][k];
			if (kn == -1) {
				difft = diff;

				if (lzk[k] >= 11) {
					dfilm = dcel * (1 - fq[k]);
					if (dfilm <= dmole) difft = 1e10 * (1 - fq[k]);
					else {
						fact = (dfilm - dmole) / (dcel - dmole);
						difft = diff / pow(fact, 10) * (1 - fq[k]);
					}
				}

				um[k] /= (1 + difft);
				vm[k] /= (1 + difft);
				wm[k] /= (1 + difft);
			}
		}
	}
}

void state() {	//֐state͕ۑvZȊȌsBł͗CtNoƂė^

#define winjg 3.82*0.7088 	//C̗Nox
#define winjl 0.03544*0.7088	//t̗Nox

	int i, j, k, n;

	for (k = 1; k <= kmax; k++) {
		rq[k] = fq[k] * rgas + (1 - fq[k]) * rliq;	//rq[k]̖͗x
		qv[k] = vol[k];		//̑̐qv[k]͊iq̐vol[k]ɒuCA̎̌덷̓NA

		if (lzk[k] == 1) {	//C̗NoiqwCł͒(lzk[k]=1)Ƃ
			i = ixk[k]; j = jyk[k];
			fq[k] = (fq[k] * dcel + winjg * dt) / (dcel + winjg * dt);	//C̗Nõ{Chfq[k],xrq[k],̑̐qv[k]^
			rq[k] = fq[k] * rgas + (1 - fq[k]) * rliq;
			qv[k] = qv[k] + ar[5][k] * winjg*dt;
		}
		if (lzk[k] >= 2 && lzk[k] <= 6 && (ixk[k] == 1 || ixk[k] == ixmax || jyk[k] == 1 || jyk[k] == jymax)) {
			//t̗NoiqwCłlzk[k]=2~6̍ɂǂɐڂiqƂ
			if (ixk[k] == 1) n = 1;
			if (ixk[k] == ixmax) n = 3;
			if (jyk[k] == 1) n = 4;
			if (jyk[k] == jymax) n = 2;
			fq[k] = fq[k] * dcel / (dcel + winjl * dt);	//t̗Nõ{Chfq[k],xrq[k],̑̐qv[k]^
			rq[k] = fq[k] * rgas + (1 - fq[k]) * rliq;
			qv[k] = qv[k] + ar[n][k] * winjl*dt;
		}
	}
}


void fqsmear() { //{ChzȂ炷
	int k, kn, n;
	double sumf;

	for (k = 1; k <= kmax; k++) {
		sumf = 0;
		for (n = 0; n <= n27m; n++) {
			kn = nex[n][k];
			if (kn >= 1) sumf += fq[kn];
			//			if (kn == -1)sumf += drywall + (fq[k] - drywall)*pow(fq[k], 0.1);
			if (kn == -1)sumf += drywall;
			if (kn == -2) sumf += 1;
		}
		fqs[k] = sumf / 27;
	}
}

void koubai() {	//iqk͂̃{Chzf(x,y,z)=ax+by+czɋߎłƂa,b,c𐄒肵AEʂ̐xNgx,y,z
	int k, km, m;
	double abc, ax, by, cz, fqkm;
	double sumxf, sumyf, sumzf;

	for (k = 1; k <= kmax; k++) {
		sumxf = 0; sumyf = 0; sumzf = 0;
		for (m = 0; m <= n27m; m++) {
			km = nex[m][k];
			if (km >= 1) fqkm = fqs[km];
			//			if (km == -1) fqkm = drywall + (fqs[km] - drywall)*pow(fqs[km], 0.1);
			if (km == -1) fqkm = drywall;
			if (km == -2) fqkm = 1;
			if (km == 0) fqkm = fqs[k];
			sumxf += dx[m] * fqkm;
			sumyf += dy[m] * fqkm;
			sumzf += dz[m] * fqkm;
		}
		ax = sumxf;
		by = sumyf;
		cz = sumzf;
		abc = sqrt(pow(ax, 2) + pow(by, 2) + pow(cz, 2));
		if (abc > 0) {
			cosax[k] = ax / abc;
			cosay[k] = by / abc;
			cosaz[k] = cz / abc;
		}
		else {
			cosax[k] = 0;
			cosay[k] = 0;
			cosaz[k] = 0;
		}
	}
}

void voidfx() {	//plic@ɂiqknEɗA{Chfr[n][k]ށĈƂiq`ɋߎ
	int n, k, kn;
	double dd, fx, fn, sx, sy, sz, hk;
	double f1, f2, f3, f4, f5, f6, f7, f8;
	double f11, f21, f51, f61;
	double f22, f32, f62, f72;
	double f33, f43, f73, f83;
	double f44, f14, f84, f54;
	double f15, f25, f35, f45;
	double f56, f66, f76, f86;

	for (k = 1; k <= kmax; k++) {

		if (fq[k]<0.05 || fq[k]>0.95) {
			for (n = 1; n <= n6; n++) {
				kn = nex[n][k];
				if (kn >= 1)  fr[n][k] = fq[kn];
				if (kn == -1) fr[n][k] = fq[k];
				if (kn == -2) fr[n][k] = fq[k];
			}

		}
		else {

			sx = cosax[k]; sy = cosay[k]; sz = cosaz[k];
			hk = (2 * xhl(fq[k]) - 1)*1.2407;
			//			1.2407=(3*8/4*pi)^(1/3)
			f1 = -sx - sy - sz - hk;
			f2 = -sx + sy - sz - hk;
			f3 = sx + sy - sz - hk;
			f4 = sx - sy - sz - hk;
			f5 = -sx - sy + sz - hk;
			f6 = -sx + sy + sz - hk;
			f7 = sx + sy + sz - hk;
			f8 = sx - sy + sz - hk;
			//-----n=1-----
			dd = dnv[1][k] / ar[1][k] / (dcel / 2);
			f11 = sx * (-1 + dd) - sy - sz - hk;
			f21 = sx * (-1 + dd) + sy - sz - hk;
			f51 = sx * (-1 + dd) - sy + sz - hk;
			f61 = sx * (-1 + dd) + sy + sz - hk;
			fx = f8max(f1, f11, f2, f21, f5, f51, f6, f61);
			fn = f8min(f1, f11, f2, f21, f5, f51, f6, f61);
			if (fx < 0) fr[1][k] = 0;
			else
				if (fn > 0) fr[1][k] = 1;
				else
					fr[1][k] = fx / (fx - fn);
			//-----n=2-----
			dd = dnv[2][k] / ar[2][k] / (dcel / 2);
			f22 = -sx + sy * (1 - dd) - sz - hk;
			f32 = sx + sy * (1 - dd) - sz - hk;
			f62 = -sx + sy * (1 - dd) + sz - hk;
			f72 = sx + sy * (1 - dd) + sz - hk;
			fx = f8max(f2, f22, f3, f32, f6, f62, f7, f72);
			fn = f8min(f2, f22, f3, f32, f6, f62, f7, f72);
			if (fx < 0) fr[2][k] = 0;
			else
				if (fn > 0) fr[2][k] = 1;
				else
					fr[2][k] = fx / (fx - fn);
			//-----n=3-----
			dd = dnv[3][k] / ar[3][k] / (dcel / 2);
			f33 = sx * (1 - dd) + sy - sz - hk;
			f43 = sx * (1 - dd) - sy - sz - hk;
			f73 = sx * (1 - dd) + sy + sz - hk;
			f83 = sx * (1 - dd) - sy + sz - hk;
			fx = f8max(f3, f33, f4, f43, f7, f73, f8, f83);
			fn = f8min(f3, f33, f4, f43, f7, f73, f8, f83);
			if (fx < 0) fr[3][k] = 0;
			else
				if (fn > 0) fr[3][k] = 1;
				else
					fr[3][k] = fx / (fx - fn);
			//-----n=4-----
			dd = dnv[4][k] / ar[4][k] / (dcel / 2);
			f44 = sx + sy * (-1 + dd) - sz - hk;
			f14 = -sx + sy * (-1 + dd) - sz - hk;
			f84 = sx + sy * (-1 + dd) + sz - hk;
			f54 = -sx + sy * (-1 + dd) + sz - hk;
			fx = f8max(f4, f44, f1, f14, f8, f84, f5, f54);
			fn = f8min(f4, f44, f1, f14, f8, f84, f5, f54);
			if (fx < 0) fr[4][k] = 0;
			else
				if (fn > 0) fr[4][k] = 1;
				else
					fr[4][k] = fx / (fx - fn);
			//-----n=5-----
			dd = dnv[5][k] / ar[5][k] / (dcel / 2);
			f15 = -sx - sy + sz * (-1 + dd) - hk;
			f25 = -sx + sy + sz * (-1 + dd) - hk;
			f35 = sx + sy + sz * (-1 + dd) - hk;
			f45 = +sx - sy + sz * (-1 + dd) - hk;
			fx = f8max(f1, f15, f2, f25, f3, f35, f4, f45);
			fn = f8min(f1, f15, f2, f25, f3, f35, f4, f45);
			if (fx < 0) fr[5][k] = 0;
			else
				if (fn > 0) fr[5][k] = 1;
				else
					fr[5][k] = fx / (fx - fn);
			//-----n=6-----
			dd = dnv[6][k] / ar[6][k] / (dcel / 2);
			f56 = -sx - sy + sz * (1 - dd) - hk;
			f66 = -sx + sy + sz * (1 - dd) - hk;
			f76 = sx + sy + sz * (1 - dd) - hk;
			f86 = sx - sy + sz * (1 - dd) - hk;
			fx = f8max(f5, f56, f6, f66, f7, f76, f8, f86);
			fn = f8min(f5, f56, f6, f66, f7, f76, f8, f86);
			if (fx < 0) fr[6][k] = 0;
			else
				if (fn > 0) fr[6][k] = 1;
				else
					fr[6][k] = fx / (fx - fn);
		}

		for (n = 1; n <= n6; n++) {
			fr[n][k] = fr[n][k] - frankx(fq[k])*(fr[n][k] - fq[k]);
		}
	}
}


void grid() { //vZ͈͂̃{NZiq̐ݒ

			  //	int i, j, l, k, n;

	ixmax = ixmaxp - 1; jymax = jymaxp - 1; lzmax = lzmaxp - 1; n6 = n6p - 1; n8 = n8p - 1;
	n27m = n27 - 1;

	cutk(); //vZ͈͂̃{NZiq̑I

	bound();	//E̐ݒ

}

void cutk() { //vZ͈͂̃{NZiq̑I ł͐~ǗHƋ`̋Ct\
	int i, j, l, k, n;
	double dcelh, xck, yck, zck, xpn, ypn, zpn;
	double ffmax, ffmin, betak;
	double xf[9], yf[9], zf[9], ff[9];
	double xsize, rpipe, xctr, yctr, rctr;

	xf[1] = -1; xf[2] = -1; xf[3] = 1; xf[4] = 1; xf[5] = -1; xf[6] = -1; xf[7] = 1; xf[8] = 1;
	yf[1] = -1; yf[2] = 1; yf[3] = 1; yf[4] = -1; yf[5] = -1; yf[6] = 1; yf[7] = 1; yf[8] = -1;
	zf[1] = 1; zf[2] = 1; zf[3] = 1; zf[4] = 1; zf[5] = -1; zf[6] = -1; zf[7] = -1; zf[8] = -1;

	xsize = dcel * (double)ixmax;	//͗̈xTCYiłyTCYj
	rpipe = xsize * 0.95 / 2;		//~ǂ̔a ~ǂ͉͗̈⏬߂ɐݒ
	xctr = xsize / 2;				//͗̈x̒ ~ǒSɂ
	yctr = xsize / 2;				//͗̈y̒    V

	for (l = 0; l <= lzmaxp; l++) {
		for (j = 0; j <= jymaxp; j++) {
			for (i = 0; i <= ixmaxp; i++) {
				kijl[i][j][l] = -1;		//kijl[i][j][l]x,y,zi,j,lԖڂɂiqw UAS̈(-1)Ƃ
			}
		}
	}


	dcelh = dcel / 2;

	k = 0;
	for (l = 1; l <= lzmax; l++) {
		zck = (double)l*dcel - dcelh;
		for (i = 1; i <= ixmax; i++) {
			xck = (double)i*dcel - dcelh;
			for (j = 1; j <= jymax; j++) {
				yck = (double)j*dcel - dcelh;
				for (n = 1; n <= 8; n++) {		//{NZiq8̒_n=1~8x,y,zWxpn,ypn,zpn^
					xpn = xck + xf[n] * dcelh;
					ypn = yck + yf[n] * dcelh;
					zpn = zck + zf[n] * dcelh;
					rctr = sqrt(pow(xpn - xctr, 2) + pow(ypn - yctr, 2));		//rctr͉~ǒS̋
					if (lzk[k] >= 11)	ff[n] = rpipe - rctr; else ff[n] = 1; //ff[n]͉~ǓŐ,~ǊOŕ  
				}							//(lzk[k]<=10)͋Ct񑊍Ƃ邽ߋ`̂܂܎c
				ffmax = f8max(ff[1], ff[2], ff[3], ff[4], ff[5], ff[6], ff[7], ff[8]); //ffmax,ffminff[n]̍őlƍŏl
				ffmin = f8min(ff[1], ff[2], ff[3], ff[4], ff[5], ff[6], ff[7], ff[8]);

				if (ffmax <= 0) {
					betak = 0; kijl[i][j][l] = -1;
				}
				else {
					if (ffmin > 0) betak = 1;
					else betak = ffmax / (ffmax - ffmin);

					//					if (betak < 0.1) betak = 0.1;

					k = k + 1; kijl[i][j][l] = k;	//HɂƔ肳ꂽ{NZiqkijl[i][j][l]ɘÅiqԍk
					ixk[k] = i; jyk[k] = j; lzk[k] = l; //iqԍkɑΉx,y,z̔ԍi,j,lL
					beta[k] = betak; vol[k] = pow(dcel, 3)*betak;	//beta[k]̓{NZiqŗH̐߂銄
					for (n = 1; n <= n6; n++) ar[n][k] = pow(dcel, 2)*pow(betak, 0.6666); //ar[n][k]̓{NZknE̖ʐρCbeta[k]Ɉˑ
				}
			}
		}
	}

	kmax = k;
	cout << "kmax=" << kmax << endl; //kmax͌vZ鑍iq ʏo͂

}


void bound() {		//E̐ݒ

	int i, im, ip, j, jm, jp, k, l, lm, lp;
	int n, nk, nr;

	for (k = 1; k <= kmax; k++) {
		i = ixk[k]; j = jyk[k]; l = lzk[k];
		im = i - 1; ip = i + 1;
		jm = j - 1; jp = j + 1;
		lm = l - 1; lp = l + 1;

		nex[0][k] = k;

		nex[1][k] = kijl[im][j][l];		//nex[n][k]͊iqknɂiqԍ nex[0][k]͎g
		nex[2][k] = kijl[i][jp][l];		//n=1~6͒ڗאڂiq,n=7~26͎΂ߕɂiq
		nex[3][k] = kijl[ip][j][l];		//אڊiqȂƂ͕ǖ(nex[n][k]=-1)ƂȂ
		nex[4][k] = kijl[i][jm][l];
		nex[5][k] = kijl[i][j][lm];
		nex[6][k] = kijl[i][j][lp];

		nex[7][k] = kijl[im][jm][lm];
		nex[8][k] = kijl[im][j][lm];
		nex[9][k] = kijl[im][jp][lm];
		nex[10][k] = kijl[i][jp][lm];
		nex[11][k] = kijl[ip][jp][lm];
		nex[12][k] = kijl[ip][j][lm];
		nex[13][k] = kijl[ip][jm][lm];
		nex[14][k] = kijl[i][jm][lm];

		nex[15][k] = kijl[im][jm][l];
		nex[16][k] = kijl[im][jp][l];
		nex[17][k] = kijl[ip][jp][l];
		nex[18][k] = kijl[ip][jm][l];

		nex[19][k] = kijl[im][jm][lp];
		nex[20][k] = kijl[im][j][lp];
		nex[21][k] = kijl[im][jp][lp];
		nex[22][k] = kijl[i][jp][lp];
		nex[23][k] = kijl[ip][jp][lp];
		nex[24][k] = kijl[ip][j][lp];
		nex[25][k] = kijl[ip][jm][lp];
		nex[26][k] = kijl[i][jm][lp];
	}

	for (k = 1; k <= kmax; k++) {
		if (lzk[k] == lzmax) nex[6][k] = -2; //ŏlzk[k]̏n=6͈͋E(-2)Ƃ
	}

	for (i = 1; i <= ixmax; i++) {
		for (j = 1; j <= jymax; j++) {
			for (l = 1; l <= lzmax; l++) {
				if (kijl[i][j][l] <= 0) kijl[i][j][l] = 0;	//iqԍȂ(̂܂܂){NZiqA܂͗̈Okijl[i][j][l]=0Ƃ
			}
		}
	}

	for (k = 1; k <= kmax; k++) {
		for (n = 1; n <= n6; n++) {
			nk = nex[n][k];
			if (nk >= 1) {
				if (n == 1) nr = 3; if (n == 2) nr = 4; if (n == 3) nr = 1;
				if (n == 4) nr = 2; if (n == 5) nr = 6; if (n == 6) nr = 5;
				if (ar[n][k] > ar[nr][nk]) ar[n][k] = ar[nr][nk];	//iqEʐς͗vZ邪A̗p
			}
		}
	}

	dx[0] = 0; dy[0] = 0; dz[0] = 0; //̗͂אڊiq(n=0~26)x,y,z^(iqdcel1Ƃ)
	dx[1] = -1; dy[1] = 0; dz[1] = 0;
	dx[2] = 0; dy[2] = 1; dz[2] = 0;
	dx[3] = 1; dy[3] = 0; dz[3] = 0;
	dx[4] = 0; dy[4] = -1; dz[4] = 0;
	dx[5] = 0; dy[5] = 0; dz[5] = -1;
	dx[6] = 0; dy[6] = 0; dz[6] = 1;

	dx[7] = -1; dy[7] = -1; dz[7] = -1;
	dx[8] = -1; dy[8] = 0; dz[8] = -1;
	dx[9] = -1; dy[9] = 1; dz[9] = -1;
	dx[10] = 0; dy[10] = 1; dz[10] = -1;
	dx[11] = 1; dy[11] = 1; dz[11] = -1;
	dx[12] = 1; dy[12] = 0; dz[12] = -1;
	dx[13] = 1; dy[13] = -1; dz[13] = -1;
	dx[14] = 0; dy[14] = -1; dz[14] = -1;

	dx[15] = -1; dy[15] = -1; dz[15] = 0;
	dx[16] = -1; dy[16] = 1; dz[16] = 0;
	dx[17] = 1; dy[17] = 1; dz[17] = 0;
	dx[18] = 1; dy[18] = -1; dz[18] = 0;

	dx[19] = -1; dy[19] = -1; dz[19] = 1;
	dx[20] = -1; dy[20] = 0; dz[20] = 1;
	dx[21] = -1; dy[21] = 1; dz[21] = 1;
	dx[22] = 0; dy[22] = 1; dz[22] = 1;
	dx[23] = 1; dy[23] = 1; dz[23] = 1;
	dx[24] = 1; dy[24] = 0; dz[24] = 1;
	dx[25] = 1; dy[25] = -1; dz[25] = 1;
	dx[26] = 0; dy[26] = -1; dz[26] = 1;
}


void suten() {//\ʒ͂ɂstx[k],sty[k],stz[k]

	int k, kn, n;
	double fqc[n6p];
	double fmax, fmin, fs, sumf;
	double rmax, rmin, delf;

	for (k = 1; k <= kmax; k++) {
		for (n = 1; n <= n6; n++) {
			kn = nex[n][k];

			if (kn >= 1) fqc[n] = fq[kn];
			//			if (kn == -1) fqc[n] = fq[k] + (drywall - fq[k])*pow(fq[k], 0.1);
			if (kn == -1) fqc[n] = fq[k];
			if (kn == -2) fqc[n] = 1;

		}
		fmax = f6max(fqc[1], fqc[2], fqc[3], fqc[4], fqc[5], fqc[6]);
		fmin = f6min(fqc[1], fqc[2], fqc[3], fqc[4], fqc[5], fqc[6]);
		rmax = fmin * rgas + (1 - fmin)*rliq;
		rmin = fmax * rgas + (1 - fmax)*rliq;
		dff[k] = (pow(rmax, 2) - pow(rmin, 2)) / (pow(rliq, 2) - pow(rgas, 2)) / 2;
		if (fq[k] > 1 - 1e-6) dff[k] = 0;
	}

	for (k = 1; k <= kmax; k++) {

		if (dff[k] < 1e-6) goto nexk;

		sumf = 0;
		for (n = 0; n <= n27m; n++) {
			kn = nex[n][k];
			if (kn >= 1) sumf += fqs[kn];
			//			if (kn == -1) sumf += drywall + (fq[k] - drywall)*pow(fq[k], 0.1);
			if (kn == -1) sumf += drywall;
			if (kn == -2) sumf += 1;
		}

		delf = fqs[k] - sumf / 27;// sumf / 27͎͊iq̃{Ch̕ϒl
		fs = 4 * sigma*delf / dcel / dcel;//\ʒ͂ɂPʑ̐ϓ̗
		curvex[k] = fs * cosax[k]; curvey[k] = fs * cosay[k]; curvez[k] = fs * cosaz[k];
	nexk:;

	}
}

void stsmear() {
	int k, kn, n;
	double sumx, sumy, sumz;
	double weit;

	for (k = 1; k <= kmax; k++) {
		sumx = curvex[k];
		sumy = curvey[k];
		sumz = curvez[k];
		weit = dff[k];
		for (n = 0; n <= n27m; n++) {
			kn = nex[n][k];
			if (kn >= 1) {
				sumx += curvex[kn] * dff[kn];
				sumy += curvey[kn] * dff[kn];
				sumz += curvez[kn] * dff[kn];
				weit += dff[kn];
			}
			if (kn == -1 || k == -2) {
				sumx += curvex[k] * dff[k];
				sumy += curvey[k] * dff[k];
				sumz += curvez[k] * dff[k];
				weit += dff[k];
			}
		}
		if (weit > 1e-6) {
			stx[k] = sumx / weit * dff[k];
			sty[k] = sumy / weit * dff[k];
			stz[k] = sumz / weit * dff[k];
		}
		else {
			stx[k] = 0;
			sty[k] = 0;
			stz[k] = 0;

		}
	}
}